//
//  FGHUDView.m
//  Created by Francesco on 1/9/06.
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////////////////////////////////////////////////

#import "FGHUDSubView.h"

#import "FGNSBezierPathAddition.h"

@implementation FGHUDSubView

- (id)initWithFrame:(NSRect)frame {
nAlpha=0.95;
clrBodyBar=[[NSColor colorWithCalibratedRed:0.10 green:0.10 blue:0.10 alpha:nAlpha]retain];
clrTitleBar=[[NSColor colorWithCalibratedRed:0.21 green:0.21 blue:0.21 alpha:nAlpha] retain];

    self = [super initWithFrame:frame];
    if (self) {
      strToolTip=[[NSString alloc] initWithString: @"FGHUDSubView"];
 	  [self addToolTipRect:frame owner:self userData:nil];
 	  positionInitialized=FALSE;
	}
    return self;
}

- (void) awakeFromNib
{
    [[self window] setAcceptsMouseMovedEvents: YES];
}


- (void) dealloc {
	
	[clrTitleBar release];
	[clrBodyBar release];
    [strToolTip release];

	[super dealloc];
}

-(NSColor*) clrTitleBar{
 return clrTitleBar;
}

-(NSColor*) clrBodyBar{
 return clrBodyBar;
}


- (void)drawRect:(NSRect)rect { //! RECT E' SOLO LA PARTE CHE DA RINFRESCARE non tutta la view !!!


   NSRect rcInvalidate= [self bounds];
 	 
    //Erase background
	[clrBodyBar set];
	NSRectFill(rcInvalidate);
   }


- (NSString *) view: (NSView *) view stringForToolTip: (NSToolTipTag) tag point: (NSPoint) point userData: (void *) userData
{
        return strToolTip;
}

- (BOOL) isFlipped
{
    return NO;
}

- (BOOL) acceptsFirstResponder
{
    return YES;
}

//we're about to get the input focus, so invalidate the area of the focus rect
- (BOOL) becomeFirstResponder
{
	if ( ![super resignFirstResponder] )
		return NO;
	
	[self setKeyboardFocusRingNeedsDisplayInRect: [self visibleRect]];
	
	return YES;
}

//we're about to loose the input focus, so invalidate the area of the focus rect
- (BOOL) resignFirstResponder
{

	if ( ![super resignFirstResponder] )
		return NO;
	
	[self setKeyboardFocusRingNeedsDisplayInRect: [self visibleRect]];
	
	return YES;
}

//our window is no longer key, so invalidate the area of our focus rect
- (void) windowDidResignKey: (NSNotification *)aNotification
{

	if ( [[self window] firstResponder] == self )
		[self setKeyboardFocusRingNeedsDisplayInRect: [self visibleRect]];
}

//our window has become key, so invalidate the area of our focus rect
- (void) windowDidBecomeKey: (NSNotification *) aNotification
{
	if ( [[self window] firstResponder] == self )
		[self setKeyboardFocusRingNeedsDisplayInRect: [self visibleRect]];
}

- (BOOL) canBecomeKeyView
{
	return YES;
}

- (BOOL) isOpaque
{
    return YES;
}

- (NSView*) hitTest:(NSPoint)thePoint
{
  NSView* answer = [super hitTest:thePoint];
  if([[self window] attachedSheet])
  {
		return [self isEqualTo:answer]?self:nil;
  }
  else return answer;
}

- (void)mouseDragged:(NSEvent *)theEvent
{
  NSPoint newPoint = [NSEvent mouseLocation];
  NSWindow* theWindow = [self window];
  NSRect windowFrame = [theWindow frame];
  NSSize szMovement;
   
 if(!positionInitialized){
  mostRecentPoint = newPoint;
  theScreen = [[NSScreen mainScreen] frame];
  theScreen.origin.y-=22;
  positionInitialized=TRUE;
  return;
 }
 
				szMovement.width = (int)newPoint.x - mostRecentPoint.x;
				szMovement.height = (int)newPoint.y - mostRecentPoint.y;
				mostRecentPoint = newPoint;

				windowFrame.origin = NSMakePoint(windowFrame.origin.x+szMovement.width, windowFrame.origin.y + szMovement.height);
			
				if(NSMaxY(windowFrame) > NSMaxY(theScreen) )
				{
					windowFrame.origin.y-=NSMaxY(windowFrame)-NSMaxY(theScreen);
				}
			
			 [theWindow setFrame:windowFrame display:YES];
	}

- (void)mouseDown:(NSEvent *)theEvent
{	
	mostRecentPoint = [NSEvent mouseLocation];
	
	[super mouseDown:theEvent];
}

- (void)mouseUp:(NSEvent *)theEvent
{
    positionInitialized=FALSE;
	[super mouseUp:theEvent];
}


//Imposto l'eventuale testo di tool tip
-(void) setToolTipText:(NSString *) aString {
 [strToolTip release];
 strToolTip=[[NSString alloc] initWithString:aString];
}




@end
