//
//  FGHudDisplayCell.h
//  FGBseHUD
//
//  Created by Francesco on 2/18/06.
//
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////


#import <Cocoa/Cocoa.h>
#import "FGHUDView.h"
#import "FGHudLevelIndicator.h"

@interface FGHudDisplayCell : NSActionCell {
    FGHUDView *aHudView;
    NSColor *foreColor;
    NSColor *backColor;
	
    NSImage *aImageLeft; //Left Image
    NSImage *aImageMiddle; //Middle Image
    NSImage *aImageRight; //right Image
	
	 NSString *theTitleRow1;
	 NSString *theTitleRow2;
	 
	 int nValore; //Visualizzato nel display numerico
	 
	 BOOL bHaveNumericDisplay;
	 
	 IBOutlet FGHudLevelIndicator *aIndicator; 
}

-(void) setNumericDisplayValue:(int)newValue; //range 0-99
-(void) setDisplayNumericVisible:(BOOL)bYesNo; 
-(void) setTitle:(NSString *) aString; //Imposto il titolo
-(void) setSubTitle:(NSString *) aString; //Imposto il sottotitolo
-(void) setOutLetIndicator:(FGHudLevelIndicator *)theIndicator;

- (void) drawTextRow1:(NSRect)cellFrame; //scrive il testo nella prima riga
- (void) drawTextRow2:(NSRect)cellFrame; //scrive il testo nella seconda riga
- (void) drawNumericDisplay:(int)valore; //0 a 99
- (void) drawNumericDisplayDecimalDigit:(int)num; 
- (void) drawNumericDisplayUnitDigit:(int)num;
-(void) indicatorValueChanged:(NSNotification *) aNotification;

@end
