//
//  FGNSBezierPathAddition.h
//
//  Created by Francesco on 1/9/06.
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>


@interface NSBezierPath (FGNSBezierPathAddition)
 + (NSBezierPath *)bezierPathWithRoundedRect:(NSRect)rect cornerRadius:(float)radius;
 - (void)appendBezierPathWithRoundedRect:(NSRect)rect cornerRadius:(float)radius;
 + (NSBezierPath *)bezierPathWithRoundedRectBottom:(NSRect)rect cornerRadius:(float)radius;
 - (void)appendBezierPathWithRoundedRectBottom:(NSRect)rect cornerRadius:(float)radius;
 + (NSBezierPath *)bezierPathWithRoundedRectTop:(NSRect)rect cornerRadius:(float)radius;
 - (void)appendBezierPathWithRoundedRectTop:(NSRect)rect cornerRadius:(float)radius;

 - (void)customHorizontalFillWithCallbacks:(CGFunctionCallbacks)functionCallbacks firstColor:(NSColor *)firstColor secondColor:(NSColor *)secondColor;
 - (void)linearGradientFillWithStartColor:(NSColor *)startColor endColor:(NSColor *)endColor;
 - (void)bilinearGradientFillWithOuterColor:(NSColor *)outerColor innerColor:(NSColor *)innerColor;
@end
